﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace FontOutline
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();

            labelSample.Text = fontDialog.Font.Name;
            labelSample.Font = fontDialog.Font;
        }

        private void buttonChangeFont_Click(object sender, EventArgs e)
        {
            fontDialog.ShowDialog();
            labelSample.Text = fontDialog.Font.Name;
            labelSample.Font = fontDialog.Font;
        }

        private void buttonExportfont_Click(object sender, EventArgs e)
        {
            char currentCharacter;
            GraphicsPath path;

            StringBuilder sb = new StringBuilder();

            for (int i = 32; i < 255; i++)
            {
                currentCharacter  = Convert.ToChar(i);

                path = new GraphicsPath();
                float dpi = 72; // TODO
                float fontSize = dpi * fontDialog.Font.SizeInPoints / 72;
                path.AddString(currentCharacter.ToString(), fontDialog.Font.FontFamily, (int)fontDialog.Font.Style, fontSize, this.ClientRectangle, StringFormat.GenericTypographic);

                if (path.PointCount > 0)
                {
                    sb.Append(String.Format("$font['{0}']['{1}'] = array(", fontDialog.Font.Name, currentCharacter.ToString()));

                    foreach (PointF p in path.PathPoints)
                    {
                        sb.Append(String.Format("{0},{1},", p.X, p.Y));
                        //sb.Append(String.Format("array({0},{1}),", p.X, p.Y));
                    }
                    sb.Remove(sb.Length - 1, 1);
                    sb.Append(");\n");
                }
            }
            textBox.Text = sb.ToString();
        }
    }
}
